/*
  Copyright 1991 Mario Goertzel and Matthew Sorrels
 
  Permission to use, copy, modify, distribute, and sell this software and its
  documentation for any purpose is hereby granted without fee, provided that
  the above copyright notice appear in all copies and that both that
  copyright notice and this permission notice appear in supporting
  documentation, and that the name of the author not be used in advertising or
  publicity pertaining to distribution of the software without specific,
  written prior permission.  The authors make no representations about the
  suitability of this software for any purpose.  It is provided "as is"
  without express or implied warranty.
 
  MARIO GOERTZEL AND MATTHEW SORRELS DISCLAIMS ALL WARRANTIES WITH 
  REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF 
  MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL MATTHEW SORRELS BE 
  LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY 
  DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
  WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, 
  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
  Authors:  Mario Goertzel and Matthew Sorrels
*/
/*
 * Capture The Flag
 *
 * Data structures and support
 *
 * Mario Goertzel <mg2p+@andrew.cmu.edu>
 * Matthew Sorrels <ms90+@andrew.cmu.edu>
 *
 * May 11, 1991
 */

/* Square Values */
#define MARSHAL    0
#define GENERAL    1
#define COLONEL    2
#define MAJOR      3
#define CAPTAIN    4
#define LIEUTENANT 5
#define SERGEANT   6
#define MINER      7
#define SCOUT      8
#define SPY        9
#define BOMB       10
#define FLAG       11
#define UNKNOWN    12
#define LAKEA      13
#define LAKEB      14
#define VICTORY1   15
#define VICTORY2   16
#define EMPTY      17

/* Square Status */
#define OPEN    0
#define PLAYER1 1
#define PLAYER2 2
#define BLOCKED 3

struct Square
{
    char status;  /* OPEN to BLOCKED above */
    char value; /* MARSHAL to EMPTY  above */
};

struct Board
{
    struct Square location[10][10];
};

struct Piece
{
    Pixmap icon;
    unsigned int width;
    unsigned int height;
};

#define INVALID 0
#define VALID 1 
#define STRIKE 2
